How to exit all the calling scripts in bash?
Asked Answered
P

4

5

Lets say I have the following scripts

a.sh

echo in a
if test 1 -ne 2; then
        echo oops
        exit 1
fi

b.sh

echo in b
./a.sh
echo in b 2

When running b.sh, I want it to exit if a.sh exited. How do I do this?

(The current output is

in b
in a
oops
in b 2

And that's not what I want)

Thanks, Rivka

Psychopath answered 7/2, 2010 at 6:42 Comment(0)
S
6

check return status of a command, corresponding variable is $?. alternatively, you can short-circuit using command || exit

Superordinate answered 7/2, 2010 at 6:45 Comment(0)
P
1
echo in b
./a.sh && echo in b 2

This basically checks that the first script does not exit non-zero. If that is true, and only then will it run the second function.

Photodrama answered 7/2, 2010 at 6:48 Comment(0)
H
0

I don't think there's a way you can do it without explicitly checking the return status of the subshell, e.g.:

# This will run b.sh, and if that exits with a non-zero status, we will also
# exit with that same status; otherwise, we continue.
./b.sh || echo $?
Helio answered 7/2, 2010 at 6:51 Comment(0)
W
0

From man bash(I don't know why the most voted answer is hidden):

set [+abefhkmnptuvxBCEHPT] [+o option-name] [arg ...] (...)

-e

Exit immediately if a pipeline (which may consist of a single simple command), a list, or a compound command (see SHELL GRAMMAR above), exits with a non-zero status. The shell does not exit if the command that fails is part of the command list immediately following a while or un‐ til keyword, part of the test following the if or elif reserved words, part of any command exe‐ cuted in a && or || list except the command following the final && or ||, any command in a pipeline but the last, or if the command's return value is being inverted with !. If a com‐ pound command other than a subshell returns a non-zero status because a command failed while -e was being ignored, the shell does not exit. A trap on ERR, if set, is executed before the shell exits. This option applies to the shell environment and each subshell environment sepa‐ rately (see COMMAND EXECUTION ENVIRONMENT above), and may cause subshells to exit before exe‐ cuting all the commands in the subshell.

If a compound command or shell function executes in a context where -e is being ignored, none of the commands executed within the compound command or function body will be affected by the -e setting, even if -e is set and a command returns a failure status. If a compound command or shell function sets -e while executing in a context where -e is ignored, that setting will not have any effect until the compound command or the command containing the function call com‐ pletes.

Washerman answered 17/5 at 19:21 Comment(0)

© 2022 - 2024 — McMap. All rights reserved.